
local cjson = require "cjson"

local filePath = "/home/develop/nginx/logs/lua_test/event.log"
local json = cjson.new()

-- table 合并函数
local function merge(target, src)
	for k, v in pairs(src) do
		target[k] = v
	end
end

-- 获取客户端真实ip
local function get_client_ip()
	local headers = ngx.req.get_headers()
	local ip = headers["X-REAL-IP"] or headers["X_FORWARDED_FOR"] or ngx.var.remote_addr or "0.0.0.0"
	return ip
end

-- 获取基础的请求头信息
local function reqHeaders()
	local headers = {}
	headers["log_ts"] = ngx.var.msec * 1000
	headers["ip"] = get_client_ip()
	headers["status"] = "200"
	headers["ua"] = ngx.var.http_user_agent or "-"
	headers["http_referer"] = ngx.var.http_referer or "-"
	return headers
end

-- event 事件字段映射
local function keyMap(headers)
	local request_method = ngx.var.request_method
	local args = {}
	if "GET" == request_method then
		args = ngx.decode_args(ngx.var.args)
	elseif "POST" == request_method then
		ngx.req.read_body()
		local receive_headers = ngx.req.get_headers()
		if receive_headers["content-type"] == "application/json" then
			local args = ngx.req.get_body_data()
			--print(json_args)
			--if json_args then
			--	args = cjson.decode(json_args)
			--end
		else
			args = ngx.req.get_post_args()
		end
	end
	local headers = args
	return json.encode(headers).."\n"
end

-- 将获取的 json 串写入文件
local function writeLog(content)
	local file = io.open(filePath, "a")
	io.output(file)
	io.write(content)
	io.close(file)
end

-- 处理过程
--local content = keyMap(reqHeaders())
local content = json.encode(reqHeaders()) .. "\n"
writeLog(content)


